diff --git a/ChangeLog b/ChangeLog
index 6d5ba0e83..ef5f8621f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -7,6 +7,7 @@
     side box fixed size fixes #6
     scroll setting retained between sessions fixes #13
     fixed file info update on existing fixes #14 fixes #15
+    reuse window on open folder on desktop fixes #16
 0.7.4   2012-04-01:
     added git build instructions to README
     better standards compliance for data doc dirs fixes #8
diff --git a/src/desktop/desktop-window.c b/src/desktop/desktop-window.c
index 3d86a21ab..48155319f 100644
--- a/src/desktop/desktop-window.c
+++ b/src/desktop/desktop-window.c
@@ -2194,12 +2194,20 @@ DesktopItem* hit_test( DesktopWindow* self, int x, int y )
  *  We really need better and cleaner APIs for this */
 void open_folders( GList* folders )
 {
-    FMMainWindow* main_window = FM_MAIN_WINDOW(fm_main_window_new());
-    //FM_MAIN_WINDOW( main_window ) ->splitter_pos = app_settings.splitter_pos;
-    gtk_window_set_default_size( GTK_WINDOW( main_window ),
-                                 app_settings.width,
-                                 app_settings.height );
-    gtk_widget_show( GTK_WIDGET(main_window) );
+    FMMainWindow* main_window;
+    
+    main_window = fm_main_window_get_last_active();
+    
+    if ( !main_window )
+    {
+        main_window = FM_MAIN_WINDOW(fm_main_window_new());
+        //FM_MAIN_WINDOW( main_window ) ->splitter_pos = app_settings.splitter_pos;
+        gtk_window_set_default_size( GTK_WINDOW( main_window ),
+                                     app_settings.width,
+                                     app_settings.height );
+        gtk_widget_show( GTK_WIDGET(main_window) );
+    }
+    
     while( folders )
     {
         VFSFileInfo* fi = (VFSFileInfo*)folders->data;
